.TH eqn2graph @MAN1EXT@ "@MDATE@" "groff @VERSION@"
.SH Name
eqn2graph \- convert an eqn equation into a cropped image
.
.
.\" ====================================================================
.\" Legal Terms
.\" ====================================================================
.\"
.\" This documentation is released to the public domain.
.
.
.\" Save and disable compatibility mode (for, e.g., Solaris 10/11).
.do nr *groff_eqn2graph_1_man_C \n[.cp]
.cp 0
.
.
.\" ====================================================================
.SH Synopsis
.\" ====================================================================
.
.SY eqn2graph
.OP \-format output-format
.RI [ convert-arguments ]
.YS
.
.
.SY eqn2graph
.B \-\-help
.YS
.
.
.SY eqn2graph
.B \-v
.
.SY eqn2graph
.B \-\-version
.YS
.
.
.\" ====================================================================
.SH Description
.\" ====================================================================
.
.I eqn2graph
reads a one-line
.IR \%@g@eqn (@MAN1EXT@)
equation from the standard input and writes an image file,
by default in Portable Network Graphics (PNG) format,
to the standard output.
.
.
.PP
The input EQN code should
.I not
be preceded by the
.B \&.EQ
macro that normally precedes it within
.IR groff (@MAN1EXT@)
macros;
nor do you need to have dollar-sign or other delimiters around the
equation.
.
.
.\" FIXME: How old?  This text hasn't been touched since 2008 at latest.
.\" Older versions of
.\" .I \%convert
.\" will produce a black-on-white graphic; newer ones may produce a
.\" black-on-transparent graphic.
.
.PP
Arguments not recognized by
.I eqn2graph
are passed to the ImageMagick or GraphicsMagick program
.IR \%convert (1).
.
.
By specifying these, you can give your image a border,
.\" Transparent backgrounds are the default in 2018.
.\" force the background transparent,
set the image's pixel density,
or perform other useful transformations.
.
.
.PP
The output image is clipped using
.IR \%convert 's
.B \-trim
option to the smallest possible bounding box that contains all the black
pixels.
.
.
.\" ====================================================================
.SH Options
.\" ====================================================================
.
.B \-\-help
displays a usage message,
while
.B \-v
and
.B \-\-version
show version information;
all exit afterward.
.
.
.TP
.BI \-format\~ output-format
Write the image in
.IR output-format ,
which must be understood by
.IR \%convert ;
the default is PNG.
.
.
.\" ====================================================================
.SH Environment
.\" ====================================================================
.
.TP
.I \%GROFF_TMPDIR
.TQ
.I \%TMPDIR
.TQ
.I TMP
.TQ
.I TEMP
These environment variables are searched in the given order to determine
the directory where temporary files will be created.
.
If none are set,
.I /tmp
is used.
.
.
.\" ====================================================================
.SH Authors
.\" ====================================================================
.
.I eqn2graph
was written by
.MT esr@\:thyrsus\:.com
Eric S.\& Raymond
.ME ,
based on a recipe for
.IR pic2graph (@MAN1EXT@),
by W.\& Richard Stevens.
.
.
.\" ====================================================================
.SH "See also"
.\" ====================================================================
.
.IR pic2graph (@MAN1EXT@),
.IR grap2graph (@MAN1EXT@),
.IR \%@g@eqn (@MAN1EXT@),
.IR groff (@MAN1EXT@),
.IR \%convert (1)
.
.
.\" Restore compatibility mode (for, e.g., Solaris 10/11).
.cp \n[*groff_eqn2graph_1_man_C]
.
.
.\" Local Variables:
.\" fill-column: 72
.\" mode: nroff
.\" End:
.\" vim: set filetype=groff textwidth=72:
